.486
.model flat,stdcall
option casemap:none

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\masm32.inc
include \masm32\include\debug.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\debug.lib


RGB macro red,green,blue
        xor eax,eax
        mov ah,blue
        shl eax,8
        mov ah,green
        mov al,red
endm


.data
ClassName db "FractalRendererClass",0
AppName  db "FractalRenderer",0

amin REAL10 -1.5
bmin REAL10 -1.0
deltas REAL10 0.004

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,0
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd
	.WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp

Mandel proc hDc : HDC
    LOCAL col : COLORREF
    
    push eax
    RGB 0, 0, 0
    mov col, eax
    pop eax
    
    push ecx		; y position - row
    push edx		; x position - column
    finit
    ;DumpFPU "The FPU #1"
    ;PrintLine
    fld bmin		; bmin laden (als konstante aufheben, zum draufaddieren am ende der schleife)
    fld deltas		; deltas laden
    fld amin		; a laden
    
    xor edx, edx
    .WHILE edx < 500	; for all in spalte
    fld st(2)		; b laden
    
    xor ecx, ecx
    .WHILE ecx < 500	; for all in reihe
    fldz		; start x
    fldz		; start y

    push eax		; zaehler
    xor eax, eax
mandel_loop:
    .IF eax < 100
	    ; xx berechnen (xq-yq+a)
	    fld st(1)		; x laden
	    fmul st(0), st(0)	; x*x=xq
	    fld st(1)		; y laden
	    fmul st(0), st(0)	; y*y=yq
	    fsubr st(0), st(1)	; xq-yq
	    fadd st(0), st(5)	; (xq-yq)+a
	    fincstp		; xx zwischenspeichern (neuer ansatz)
	    ;fstp st(7)		; xx zwischenspeichern (im dedugger nicht sichtbar :-()
	    			; st(7) freigeben??? (scheinbar nicht ntig nach pop)
	    fincstp		; stack manuell poppen
	    ffree st(7)		; gepopptes register manuell freigeben (als empty markieren - wichtig!)
	    
	    ; y berechnen (2*x*y+b)
	    fld1
	    fadd st(0), st(0)	; gib mir ne 2 (vielleicht als Konstante aus mem laden)
	    fmulp st(1), st(0)	; y*2
	    fmul st(0), st(1)	; (y*2)*x
	    fadd st(0), st(2)	; (y*2*x)+b
	    
	    fld st(6)		; xx laden
	    ffree st(7)		; clean up (fld pusht vorm laden (6+1))
	    fstp st(2)		; x=xx
	    
	    ; fertig? (xq+yq>4?)
	    fld st(1)		; x laden
	    fmul st(0), st(0)	; x*x=xq
	    fld st(1)		; y laden
	    fmul st(0), st(0)	; y*y=yq
	    faddp st(1), st(0)	; xq+yq
	    fld1
	    fadd st(0), st(0)
	    fmul st(0), st(0)	; gib mir ne 4 (vielleicht als Konstante aus mem laden)
	    ;DumpFPU "The FPU #?"
    	    ;PrintLine
	    fcompp		; cmp 4, xq+yq - und dann weg mit den beiden
	    
	    ;------------------------------------------------------------------------------------
	    
	    ; flags auswerten
	    push ax		; ax retten
	    fnstsw ax		; statuswort in ax speichern
	    sahf		; ah ins untere wort des flagregisters kopieren
	    jp nc
	    ja greater
	    jbe less
	    PrintText "Jump to weiter!?"
    	    PrintLine
	    jmp weiter
    .ELSE
    	    ; punkt gefunden der wohl wahrscheinlich zur mandelbrotmenge gehrt
    	    push edx
    	    push ecx
    	    invoke SetPixel, hDc, edx, ecx, col
    	    pop ecx
    	    pop edx
	    jmp weiter_ot
    .ENDIF
nc:
    PrintText "Not comparable!"
    PrintLine
    DumpFPU "The FPU #ERROR"
    PrintLine
    pop ax
    pop eax
    jmp ende
greater:		; 4 > berechnete zahl
    ;PrintText "Weiter gehts!"
    ;PrintLine
    pop ax
    inc eax
    jmp mandel_loop
less:			; 4 <= berechnete zahl
    ; punkt 'verreist' -> entsprechend einfrben
    ;PrintText "Abbrechen!"
    ;PrintLine
    ; weiter
weiter:
    pop ax
    ;PrintDec eax
weiter_ot:
    pop eax
    ; beiden obersten register freigeben (2 x poppen)
    ; damit es weitergehen kann
    fincstp
    fincstp
    ffree st(6)
    ffree st(7)
    fadd st(0), st(2)	; b=b+ds
    inc ecx		; y++
    .ENDW		; for all in reihe
    ;DumpFPU "The FPU #?"
    ;PrintLine
    ; neues b abrumen
    fincstp
    ffree st(7)
    fadd st(0), st(1)	; a=a+ds
    inc edx		; x++
    .ENDW		; for all in spalte
    ;DumpFPU "The FPU #2"
    ;PrintLine
ende:
    pop edx
    pop ecx
    ret
Mandel endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_PAINT
            ;PrintString szText
            	invoke BeginPaint,hWnd, ADDR ps
		mov    hdc,eax
		invoke Mandel, hdc
		;invoke GetClientRect,hWnd, ADDR rect
		;invoke DrawText, hdc,ADDR OurText,-1, ADDR rect, DT_SINGLELINE or DT_CENTER or DT_VCENTER
		invoke EndPaint,hWnd, ADDR ps
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp
end start
